#include <stdlib.h>
#include "fxlib.h"

#include "affichage.h"
#include "fonctions.h"
#include "struc.h"
#include "gray.h"


int afficher(Doodle* doodle, Plate* listePlates, Autres* autres, unsigned char contrast)
{
	int i,j;
	unsigned char ligne = 126;
	Screen* screen;

	screen = gray_getScreen();
	doodle->x = doodle->saut.origine + doodle->saut.hauteur - doodle->posCamera;

	afficher_plateformes(listePlates, doodle->posCamera);
	TraceImg(doodle->x, doodle->y, doodle->dernierAppui, doodle->bouclier, doodle->saut.modeSaut);



	ML_vertical_line_buffer(120, 0, 64, BLACK, screen->VRAM2);
	ML_rectangle_buffer(121, 0, 128, 64, 0, WHITE, WHITE, screen->VRAM2);



	afficher_nombres_buffer(doodle->score, 122, 2, screen->VRAM1);
	afficher_nombres_buffer(doodle->score, 122, 2, screen->VRAM2);/*
	afficher_nombres_buffer(nombreElements(listePlates), 122, 30, screen->VRAM1);
	afficher_nombres_buffer(nombreElements(listePlates), 122, 30, screen->VRAM2);
	afficher_nombres_buffer(doodle->level, 122, 50, screen->VRAM1);
	afficher_nombres_buffer(doodle->level, 122, 50, screen->VRAM2);*/
	afficher_nombres_buffer(contrast, 122, 50, screen->VRAM1);
	afficher_nombres_buffer(contrast, 122, 50, screen->VRAM2);


/*
	afficher_nombres_buffer(autres->var, 5, 5, screen->VRAM1);
	afficher_nombres_buffer(autres->var, 5, 5, screen->VRAM2);*/




	j = doodle->posCamera/16*16;
	for(i=0; i<136; i+=16)// affichage des traits sur les bords
	{
		ML_bmp_or_cl_buffer(&ligne, j+i -doodle->posCamera, 0, 8, 1, screen->VRAM2);
		ML_bmp_or_cl_buffer(&ligne, j+i -doodle->posCamera, 63, 8, 1, screen->VRAM2);
	}

}

void afficher_plateformes(Plate* listePlates, int camera)
{
	int x, i, j;
	unsigned char plateforme[] = {96, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 96};
	unsigned char ressort[] = {64, 192, 64};
	unsigned char ponctuelleVRAM2[] = {96, 144, 144, 144, 144, 144, 144, 144, 144, 144, 144, 96};
	unsigned char ponctuelleVRAM1[] = {0, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 0};
	unsigned short jetPackVRAM2[] = { 65472, 32864, 65472, 8448, 65472, 32864, 65472 };
	unsigned short jetPackVRAM1[] = { 32640, 32640, 32640, 0, 32640, 32640, 32640 };
	Plate *tmp;
	Screen* screen;

	tmp = listePlates;
	screen = gray_getScreen();

    while(tmp) // Tant que l'on n'est pas au bout de la liste
    {
        x = tmp->x - camera;
		if(x<128)
		{
			if(tmp->mode == PONCTUELLE)
			{
				ML_bmp_or_cl_buffer(ponctuelleVRAM1, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM1);
				ML_bmp_or_cl_buffer(ponctuelleVRAM2, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM2);
			}
			else if(tmp->mode == TEMPORISEE)
			{
				if(tmp->positionTempo > 0)
				{
					for(i=0; i<4; i++)
					{
						for(j=0; j<12; j++)
						{
							if(tmp->pixelsTempo[12*i+j] == 1)
								ML_pixel_buffer(x+i, tmp->y+j, BLACK, screen->VRAM1);
						}
					}
				}
				else
					ML_bmp_or_cl_buffer(plateforme, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM1);
			}
			else// plateforme normale
			{
				ML_bmp_or_cl_buffer(plateforme, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM1);
				ML_bmp_or_cl_buffer(plateforme, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM2);

			}
			if(tmp->ressort==1)
			{
				ML_bmp_or_cl_buffer(ressort, x+HAUTEUR_PLATEFORME, tmp->y+1, 2, 3, screen->VRAM1);
				ML_bmp_or_cl_buffer(ressort, x+HAUTEUR_PLATEFORME, tmp->y+1, 2, 3, screen->VRAM2);
			}
			else if(tmp->ressort == 2)
			{
				ML_bmp_or_cl_buffer(ressort, x+HAUTEUR_PLATEFORME, tmp->y+8, 2, 3, screen->VRAM1);
				ML_bmp_or_cl_buffer(ressort, x+HAUTEUR_PLATEFORME, tmp->y+8, 2, 3, screen->VRAM2);
			}
			else if(tmp->mode == JETPACK)
			{
				ML_bmp_or_cl_buffer((unsigned char*)jetPackVRAM1, x+HAUTEUR_PLATEFORME, tmp->y +3, 11, 7, screen->VRAM1);
				ML_bmp_or_cl_buffer((unsigned char*)jetPackVRAM2, x+HAUTEUR_PLATEFORME, tmp->y +3, 11, 7, screen->VRAM2);
			}/*
			if(tmp->vecteur != 0)
			{
				ML_vertical_line_buffer(x+4, tmp->y, tmp->y+5, BLACK, screen->VRAM1);
				ML_vertical_line_buffer(x+4, tmp->y, tmp->y+5, BLACK, screen->VRAM2);
			}*/
		}
        tmp = tmp->nxt;
    }
}


void TraceImg(int x, int y, int dernierAppui, int bouclier, Mode_Saut modeSaut)
{

	unsigned short centreVRAM2[] = { 15360, 63520, 14384, 63504, 14352, 63504, 14384, 63520, 15360 };
	unsigned short centreVRAM1[] = { 16256, 61408, 12272, 61424, 12272, 61424, 12272, 61408, 16256 };
	unsigned char  droiteVRAM2[] = {120, 8, 0, 0, 0, 32, 0, 32, 8, 144, 144, 96, 144};
	unsigned char  droiteVRAM1[] = {120, 8, 0, 0, 0, 32, 0, 32, 8, 240, 240, 96, 144};
	unsigned char  gaucheVRAM2[] = {144, 96, 144, 144, 8, 32, 0, 32, 0, 0, 0, 8, 120};
	unsigned char  gaucheVRAM1[] = {144, 96, 240, 240, 8, 32, 0, 32, 0, 0, 0, 8, 120};
	unsigned short jetPackVolDroiteVRAM2[] = { 49152, 61440, 65534, 64515, 65534, 61664, 49152};
	unsigned short jetPackVolDroiteVRAM1[] = { 0, 0, 4094, 4095, 4094, 224, 0 };

	unsigned short jetPackVolGaucheVRAM2[] = { 49152, 61664, 65534, 64515, 65534, 61440, 49152 };
	unsigned short jetPackVolGaucheVRAM1[] = { 0, 224, 4094, 4095, 4094, 0, 0 };
	Screen* screen;

	screen = gray_getScreen();


	ML_bmp_or_cl_buffer((unsigned char*)centreVRAM1, x, y, 12, 9, screen->VRAM1);
	ML_bmp_or_cl_buffer((unsigned char*)centreVRAM2, x, y, 12, 9, screen->VRAM2);

	if(dernierAppui == DROITE)
	{
		ML_bmp_or_cl_buffer(droiteVRAM1, x+5, y, 5, 13, screen->VRAM1);
		ML_bmp_or_cl_buffer(droiteVRAM2, x+5, y, 5, 13, screen->VRAM2);
		if(modeSaut == JET)
		{
			ML_bmp_or_cl_buffer((unsigned char*)jetPackVolDroiteVRAM1, x-3, y-6, 16, 7, screen->VRAM1);
			ML_bmp_or_cl_buffer((unsigned char*)jetPackVolDroiteVRAM2, x-3, y-6, 16, 7, screen->VRAM2);
		}
	}
	else
	{
		ML_bmp_or_cl_buffer(gaucheVRAM1, x+5, y-4, 5, 13, screen->VRAM1);
		ML_bmp_or_cl_buffer(gaucheVRAM2, x+5, y-4, 5, 13, screen->VRAM2);
		if(modeSaut == JET)
		{
			ML_bmp_or_cl_buffer((unsigned char*)jetPackVolGaucheVRAM1, x-3, y+8, 16, 7, screen->VRAM1);
			ML_bmp_or_cl_buffer((unsigned char*)jetPackVolGaucheVRAM2, x-3, y+8, 16, 7, screen->VRAM2);
		}
	}
	if(bouclier)
	{
		ML_filled_circle_buffer(x+5, y+4, 10, BLACK, screen->VRAM2);
		ML_circle_buffer(x+5, y+4, 10, WHITE, screen->VRAM2);
		ML_circle_buffer(x+5, y+4, 10, BLACK, screen->VRAM1);

	}

}

int nombreElements(Plate* liste)
{
    int nb;
    Plate* tmp;
	tmp = liste;
    for(nb=0;tmp; nb++)
        tmp = tmp->nxt;
    return nb;
}
