#include <stdlib.h>
#include "fxlib.h"

#include "syscall.h"
#include "fonctions.h"
#include "struc.h"
#include "gray.h"
#include "menu.h"


int menu(int tabScores[], int* score, int* keyRight, int* keyLeft);

void ML_set_contrast(unsigned char contrast)
{
	char *LCD_register_selector = (char*)0xB4000000, *LCD_data_register = (char*)0xB4010000;
	*LCD_register_selector = 6;
	*LCD_data_register = contrast;
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
   int score = 0;
	int keyLeft = KEY_CTRL_UP, keyRight = KEY_CTRL_DOWN;
	int tabScores[10] = {0};

	if(gray_init() ==0)
		return 0;
	srand(RTC_GetTicks());


	ML_set_contrast(161);
	//read_save_keys(&keyLeft, &keyRight, tabScores);



	while(!menu(tabScores, &score, &keyRight, &keyLeft));

	gray_quit();
	reset_calc();
    return 1;
}

int menu(int tabScores[], int* score, int* keyRight, int* keyLeft)
{
	unsigned short doodleImg[] = { 0xF000, 0xFF80, 0xDFE0, 0xC0E0, 0xC060, 0xC060, 0xE060, 0x78C0, 0x3FC0, 0xF00, 0, 0, 0x7C00, 0xFE00, 0xC700, 0x8300, 0xC300, 0xE300, 0x7E00, 0x3C00, 0, 0, 0x7C00, 0xFE00, 0xC700, 0x8300, 0xC300, 0xE300, 0x7E00, 0x3C00, 0, 0, 0x7C00, 0xFE00, 0xC700, 0x8300, 0xC300, 0xF600, 0xFF80, 0x1FE0, 0xE0, 0, 0xF000, 0xFF80, 0xFE0, 0x60, 0, 0x7C00, 0xFE00, 0xDB00, 0x9B00, 0xDB00, 0xDF00, 0x5E00};
	unsigned short jump[] = { 0x400, 0x1C00, 0x1800, 0x1800, 0x1800, 0x1E00, 0xFF0, 0x1FC, 0x1C, 0, 0x1E00, 0x1FE0, 0x11E0, 0x1000, 0x800, 0x1F00, 0x1FE0, 0x1E0, 0, 0, 0, 0x1F00, 0x1FE0, 0x1E0, 0x40, 0x1860, 0x1FE0, 0xFE0, 0xC0, 0x60, 0x1E60, 0x1FE0, 0x3C0, 0, 0xE000, 0xFF00, 0x3FE0, 0x1DE0, 0x1040, 0x1860, 0x1C60, 0xFE0, 0x7C0 };
	unsigned short doodleImgDroite[13] = { 0x3FC0, 0xE860, 0x2830, 0xE810, 0x2810, 0xE910, 0x2830, 0xE920, 0x3C40, 0x480, 0x480, 0x300, 0x480 };
	unsigned char doodleImgFonce[] = {240, 248, 252, 252, 220, 248, 216, 112, 96, 96};
	unsigned char doodleImgClair[] = {128, 128, 128, 128, 128, 128, 128};
	int posMenu = 2, upLeft = 0, upRight = 0, exeUp = 0;
	Doodle doodle;
	Screen* screen=NULL;


	screen = gray_getScreen();
	doodle.x = 0;
	doodle.y = 50;
	doodle.saut.position = -51;
	doodle.saut.hauteur = 0;
	doodle.saut.origine = 0;

	while(1)
	{

		gray_clearVRAM();
		doodle.saut.position += 1;
		if(doodle.saut.position > 50)
			doodle.saut.hauteur -= 1;
		else
			doodle.saut.hauteur = 50-0.02*(doodle.saut.position)*(doodle.saut.position);// fonction 50-0.02x²

		ML_bmp_or_buffer((unsigned char*)doodleImg, 100, 5, 11, 54, screen->VRAM1);
		ML_bmp_or_buffer((unsigned char*)doodleImg, 100, 5, 11, 54, screen->VRAM2);
		ML_bmp_or_buffer((unsigned char*)jump, 80, 10, 14, 43, screen->VRAM1);
		ML_bmp_or_buffer((unsigned char*)jump, 80, 10, 14, 43, screen->VRAM2);
		ML_bmp_or_buffer((unsigned char*)doodleImgDroite, doodle.saut.hauteur, doodle.y, 12, 13, screen->VRAM1);
		ML_bmp_or_buffer((unsigned char*)doodleImgDroite, doodle.saut.hauteur, doodle.y, 12, 13, screen->VRAM2);
		ML_bmp_or_buffer(doodleImgClair, doodle.saut.hauteur+5, doodle.y+1, 6, 10, screen->VRAM2);
		ML_bmp_or_buffer(doodleImgFonce, doodle.saut.hauteur+3, doodle.y+1, 1, 7, screen->VRAM1);

		ML_rectangle_buffer(18+posMenu*10, 3, 27+posMenu*10, 47, 1, BLACK, WHITE, screen->VRAM1);
		ML_rectangle_buffer(18+posMenu*10, 3, 27+posMenu*10, 47, 1, BLACK, WHITE, screen->VRAM2);

		afficher_chaine("JOUER", 40, 5, screen->VRAM1);
		afficher_chaine("JOUER", 40, 5, screen->VRAM2);
		afficher_chaine("OPTIONS",30, 5, screen->VRAM1);
		afficher_chaine("OPTIONS",30, 5, screen->VRAM2);
		afficher_chaine("RECORDS",20, 5, screen->VRAM1);
		afficher_chaine("RECORDS",20, 5, screen->VRAM2);
		afficher_chaine("QUITTER",10, 5, screen->VRAM1);
		afficher_chaine("QUITTER",10, 5, screen->VRAM2);

		if(*score)
		{
			afficher_nombres_buffer(*score, 70, 40, screen->VRAM1);
			afficher_nombres_buffer(*score, 70, 40, screen->VRAM2);
			afficher_chaine("SCORE", 70, 5, screen->VRAM1);
			afficher_chaine("SCORE", 70, 5, screen->VRAM2);
		}
		gray_swapBuffers();
		if(doodle.saut.position == 50)
			doodle.saut.position = -51;
		if(IsKeyDown(KEY_CTRL_EXE) && exeUp)// si exe a ete relache, on peut commencer a jouer
		{
			switch(posMenu)
			{
				case -1: return 1;
				case 0 : menu_score(tabScores);   break;
				case 1 : touches(keyLeft, keyRight, tabScores); break;
				case 2 : if(jeu(score, *keyLeft, *keyRight))
							return 1;/*
						else
						{
							/*maj_records(score, tabScores);
							write_save_keys(*keyLeft, *keyRight, tabScores);
							return 0;
						}*/
						break;
				default:break;
			}
		}
		if( !IsKeyDown(KEY_CTRL_EXE))// si exe est relache
			exeUp = 1;
		if(IsKeyDown(KEY_CTRL_EXIT))
			return 1;
		if(!IsKeyDown(KEY_CTRL_RIGHT))
			upRight = 1;
		if(!IsKeyDown(KEY_CTRL_LEFT))
			upLeft = 1;
		if(IsKeyDown(KEY_CTRL_LEFT) && posMenu >-1 && upLeft)
		{
			posMenu --;
			upLeft = 0;
		}
		if(IsKeyDown(KEY_CTRL_RIGHT) && posMenu <2 && upRight)
		{
			posMenu ++;
			upRight = 0;
		}
		//Sleep(6);
	}

	return 0;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section

