#include <stdlib.h>
#include "fxlib.h"

#include "jeu.h"

#include "collisions.h"
#include "syscall.h"
#include "fonctions.h"
#include "struc.h"
#include "gray.h"
#include "plates.h"
#include "gameover.h"


int jeu(int* score, int keyLeft, int keyRight)
{
	int i, quitter = 0, ancienLevel = 0;
	unsigned char contrast = 161;
	Plate* listePlates = NULL;
	Doodle doodle;
	Autres autres;

	initialiseDoodle(&doodle);
	changer_level(0, &autres);
	/*autres.platesTempo.nbRestants = 4;*/
	listePlates = initialise_plates(listePlates);



	gray_clearVRAM();


	while(IsKeyDown(KEY_CTRL_EXE));

	// vram 1 : gris fonce, vram 2 : gris clair

	while(!quitter)
	{
		if(IsKeyDown(keyLeft))
		{
			doodle.y -=1 ;
			doodle.dernierAppui = GAUCHE;
				if(doodle.y <-5) doodle.y=59;
		}else if(IsKeyDown(keyRight))
		{
			doodle.y +=1 ;
			doodle.dernierAppui = DROITE;
			if(doodle.y >59)doodle.y = -5;
		}
		else if(IsKeyDown(KEY_CTRL_F5))
		{
			contrast --;
			ML_set_contrast(contrast);
			for(i=0; i<990000; i++);
		}
		else if(IsKeyDown(KEY_CTRL_F6))
		{
			contrast ++;
			ML_set_contrast(contrast);
			for(i=0; i<990000; i++);
		}
		else
			for(i=0; i<20000; i++);// temps d'attente si aucune touche pressee
		if(IsKeyDown(KEY_CTRL_MENU))//menu pause
		{
			if(pause(doodle.score))
				return 1;
		}
		if( IsKeyDown(KEY_CTRL_EXIT) )
			return 1;/*
		if( IsKeyDown(KEY_CTRL_RIGHT)  )
			doodle.saut.origine ++ ;
		if( IsKeyDown(KEY_CTRL_LEFT)  )
			doodle.saut.origine -- ;*/



		doodle.level = (int) (doodle.score / 2000);// 1 level tous les 2000 points

		if(ancienLevel != doodle.level)
		{
			changer_level(doodle.level, &autres);
			ancienLevel = doodle.level;
		}

		collisions_doodle(&doodle, listePlates);
		sauter_doodle(&(doodle.saut));
		deplacer_camera(&doodle);
		listePlates = creer_plates(listePlates, doodle.posCamera, doodle.level, doodle.score, &autres);
		listePlates = supprimerPlates(listePlates, doodle.posCamera);
		listePlates =  deplacerPlates(listePlates);
		listePlates =  actualiserPlates(listePlates);

		afficher(&doodle, listePlates, &autres, contrast);
		if(doodle.saut.origine + doodle.saut.hauteur < doodle.posCamera)// si le doodle va trop bas
			quitter = 1;

		gray_swapBuffers();
		gray_clearVRAM();
		/*for(i=0; i<30000; i++);

		for(i=0; i<50000; i++);
		for(i=0; i<500000; i++);
		*/
	}

	*score = doodle.score;
	game_over(doodle.score, doodle.saut.origine + doodle.saut.hauteur, doodle.y, doodle.posCamera, listePlates);
	while( listePlates = supprimerElementEnTete(listePlates));// on supprime les plateformes, a modifier pendant la chute du doodle pour rapidite.


	return 0;
}

void initialiseDoodle(Doodle* doodle)
{
	doodle->x = 0;
	doodle->y = 30;
	doodle->posCamera = 0;
	doodle->saut.position = -51;
	doodle->saut.hauteur = 0;
	doodle->saut.origine = 0;
	doodle->saut.modeSaut = NORMAL;
	doodle->dernierAppui = DROITE;
	doodle->score = 0;
	doodle->level = 0;
	doodle->bouclier = 0;
}

int sauter_doodle(Saut* sautDoodle)
{
	if(sautDoodle->modeSaut == NORMAL)
	{
		sautDoodle->position += 1;
		if(sautDoodle->position > 50)
			sautDoodle->hauteur -= 2;
		else
			sautDoodle->hauteur = 50-0.02*(sautDoodle->position)*(sautDoodle->position);// fonction 50-0.02x²
	}
	if(sautDoodle->modeSaut == RESSORT)
	{
		sautDoodle->position += 1;
		if(sautDoodle->position >= 0)// si on arrive en haut, on revient en normal
		{
			sautDoodle->modeSaut = NORMAL;
			sautDoodle->position = -51;
		}
		else
		{
			sautDoodle->origine +=3;
			sautDoodle->hauteur = 0;
		}

	}
	if(sautDoodle->modeSaut == JET)
	{
		sautDoodle->position += 1;
		if(sautDoodle->position >= 0)// si on arrive en haut, on revient en normal
		{
			sautDoodle->modeSaut = NORMAL;
			sautDoodle->position = -51;
		}
		else
		{
			sautDoodle->origine +=3;
			sautDoodle->hauteur = 0;
		}
	}
	return 0;
}



void deplacer_camera(Doodle* doodle)
{
	int i;
	i = doodle->saut.origine + doodle->saut.hauteur - doodle->posCamera -70;

	if( i > 0)// si la position du doodle superieur a 70, on monte la camera
	{
		doodle->posCamera +=  i;
		doodle->score += i;
	}
}

int changer_level(int level, Autres* autres)// (rand() % (MAX - MIN + 1)) + MIN;
{
	int tmp;
	switch(level)
	{
		case 0://niveau 0, donc on commence la partie
			autres->var = (rand() % (2000-100+1)) + 100;
			break;
		case 1:
			autres->var = (2000*level) + (rand() % (2000-100+1)) + 100;
			break;
		default : break;
	}

	if (!(level&1))//si level est pair
	{
		autres->platesTempo.x = (2000*level) + (rand() % (2000-100+1)) + 100;
		autres->platesTempo.nbRestants = level+4;
	}/*
	autres->mob.hauteur = (2000*level) + (rand() % (1900 - 100+ 1)) + 0;
	autres->mob.type = (rand()%(6) + 1);*/
	return 0;
}
